#######################################################################
# Values mặc định của tất cả các chart sử dụng template của chart này #
#######################################################################

# -- Global value sharing giữa các chart
# Các value này là mặc định để cho phép chia sẻ trong toàn bộ cấu trúc
# chart cha & chart con
global:
  # -- Các value liên quan đến tính chất của dự án áp dụng chart này
  project:
    # -- Base domain name của project khi expose ra Internet
    domain: api-connect.io
    # -- Sub domain name nếu có của project khi expose
    subDomain: ""

  deploy:
    # -- Annotations cho tất cả các deployment
    annotations: {}
    # -- Tier môi trường cho tất cả các deployment
    env: ""
  app:
    image:
      # -- Repository của container chính của tất cả các deployment
      repository: alpine
      # -- Tag cho container chính của tất cả các deployment
      tag: ""
  storage: {}
  security: {}

# -- Các value liên quan đến tính chất của các deployment/statefulset/deamonset/cronjob/job
deploy:
  # -- Số lượng replica pod áp dụng cho deployment/statefulset
  # hoặc số lượng pod chạy song song áp dụng cho job/cronjob
  replicaCount: 1
  # -- Kubernetes deployment/statefulset/deamonset strategy để replace pod hiện tại sang pod mới
  strategy:
    type: "RollingUpdate"
  # -- Chính sách quản lý pod trong statefulset khi scale
  podManagementPolicy: "OrderedReady"
  cron:
    # -- Lịch chạy cronjob
    schedule: "0 17 * * *"
    # -- Chỉ định chạy đồng thời các job
    # https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.20/#cronjobspec-v1beta1-batch
    concurrencyPolicy: "Forbid"
    failedJobsHistoryLimit: 10
    successfulJobsHistoryLimit: 10
  # -- Annotation của deployment/statefulset/daemonset/cronjob/job
  annotations: {}
  # -- Annotation của pod trong deployment/statefulset/daemonset/cronjob/job
  podAnnotations: {}
  # -- Label selector để assign pod vào node.
  # https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/
  nodeSelector: {}
  # -- Toleration cho phép lên lịch pod vào node có taint phù hợp.
  # https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/
  tolerations: []
  # -- Affinity cho phép assign pod vào node theo biểu thức logic.
  # https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/
  affinity: {}
  # -- Restart policy của pod trong deployment/statefulset/daemonset/cronjob/job
  restartPolicy: Always
  # -- Horizontal autoscale pod dựa trên các điều kiện.
  # https://kubernetes.io/docs/tasks/run-application/horizontal-pod-autoscale/
  autoscaling:
    # -- Chỉ định chạy autoscale
    enabled: true
    # -- Đối tượng được scale
    kind: Deployment
    # -- Số lượng replica pod tối đa được scale
    maxReplicas: 6
    minReplicas: 3
    # -- Metric được đo để scale
    metrics: 
      - resource:
          name: memory
          target:
            averageUtilization: 80
            type: Utilization
        type: Resource
      - resource:
          name: cpu
          target:
            averageUtilization: 80
            type: Utilization
        type: Resource
  # -- Ngăn chặn pod bị gián đoạn dựa trên các điefu kiện.
  # https://kubernetes.io/docs/tasks/run-application/configure-pdb/
  podDisruptionBudget:
    # -- Chỉ định ngăn chặn gián đoạn
    enabled: true
    # -- Số lượng pod tối thiểu cần đảm bảo
    minAvailable: 1
  # -- Timezone của pod trong deployment/statefulset/daemonset/cronjob/job
  # timezone: "Asia/Ho_Chi_Minh"
  # -- Loại môi trường được deploy
  env: ""
  # -- Tiền tố tên ClusterIssuer của cert-manager
  # certManagerPrefix: "cloudflare"

# -- Các value liên quan đến app chính
app:
  # -- Container name, nếu để trống, "main" sẽ được sử dụng thay tên
  name: "main"
  # -- Container image
  image:
    # -- Repository của container image
    repository: ""
    # -- Tag của container image
    tag: ""
    # -- Cách lấy container image từ repository
    pullPolicy: IfNotPresent
  # -- Command trong khi start container
  command: []
  # -- Lifecycle command của container
  lifecycle: []
  # -- Environment variable hard cođe của container
  env: []
  # -- Environment variable lấy từ các resource khác của container
  envFrom: []
  # -- Thông tin volume được gắn vào container
  volumeMounts: []
  # -- Thông tin liên quan đến cung cấp tài nguyên CPU, RAM cho container
  resources: {}
  # -- Danh sách các port được expose & healthcheck
  ports:
    - name: http
      internal: 80
      external: 80
      healthCheck:
        liveness:
          type: http
          endpoint: /
          # failureThreshold: 3
          # initialDelaySeconds: 10
          # periodSeconds: 30
          # successThreshold: 1
          # timeoutSeconds: 5
        readiness:
          type: http
          endpoint: /
          # failureThreshold: 1
          # initialDelaySeconds: 5
          # periodSeconds: 5
          # successThreshold: 1
          # timeoutSeconds: 5
  securityContext: {}

# -- Các value liên quan đến initContainer, là danh sách các object có trường giống `app`
initContainers: []
# -- Các value liên quan đến sidecarContainer, là danh sách các object có trường giống `app`
sidecarContainers: []

# -- Các value liên quan đến bảo mật pod
security:
  # -- Các secret chứa dockerconfig để pull image
  imagePullSecrets: []
  # -- Service account cho pod
  serviceAccount:
    # -- Annotation thêm vào service account
    annotations: {}
    # -- Tên service account. Nếu trường này trống thì nameSuffix hoặc parentNameSuffix mới có hiệu lực.
    name: ""
    # -- Hậu tố trong tên service account. Tên được sinh ra có dạng [tên release]-[hậu tố]
    parentNameSuffix: ""
    # -- Hậu tố trong tên service account. Tên được sinh ra có dạng [tên chart]-[hậu tố]
    nameSuffix: ""
  # -- Security context cho pod
  securityContext: {}
  # -- RBAC cho service account
  rbac:
    # -- Loại RBAC: Role hoặc ClusterRole
    type: Role
    # -- Các rule trong RBAC
    rules: []

# -- Các value liên quan đến tính chất Service
service:
  # -- Type của service
  type: ClusterIP
  # -- Annotation của service
  annotations: {}
  headless:
    # -- Tạo thêm service dạng headless hoặc không
    enabled: false
    # -- Annotation của service với headless
    annotations: {}
  # -- IP nếu có của LoadBalancer nếu type là LoadBalancer
  ip: ""

# -- Các value liên quan đến tính chất Ingress
ingress:
  # -- Cờ xác định expose HTTP/HTTPS ra Internet
  enabled: true
  # -- Class của ingress
  class: nginx
  # -- Annotation của ingress
  annotations: {}
  # -- List port của service được expose và port, tương ứng với các port của service
  paths:
    - endpoint: /
      type: Prefix
      portName: http

  # -- Các host bổ sung
  extraHosts: []
    # - name: "*.xxxxx.vn"
      # paths:
      # - endpoint: /
        # type: Prefix
        # portName: http
    # - name: "test.xxxxx.vn"
      # paths:
      # - endpoint: /
        # type: Prefix
        # portName: http

# -- Các value liên quan đến tạo configMap từ file
configMaps: []
  # - nameSuffix: test
  #   name: ""
  #   envList:
  #     ENV1: value1
  #   volumeList:
  #     file1.txt: "assets/file1.txt"

# -- Các value liên quan đến tạo secret từ file
secrets: []
  # - nameSuffix: test
  #   name: ""
  #   data:
  #     secret1: "assets/file1.txt"

# -- Các value liên quan đến storage data
storage:
  # -- Danh sách volume có sẵn để mount vào deployment/daemonset/statefulset
  volumes: []
  # -- Các value liên quan đến persistence volume
  persistences: []
    # - nameSuffix: ""
    #   name: ""
    #   storageClass: ""
    #   size: 8Gi
    #   accessModes:
    #     - "ReadWriteOnce"
    #   annotations: {}
    #   volumeName: ""
